s3cmd(1)

NAME
s3cmd - tool for managing Amazon S3 storage space and Amazon CloudFront content delivery network

SYNOPSIS
s3cmd [OPTIONS] COMMAND [PARAMETERS]

DESCRIPTION

s3cmd is a command line client for copying files to/from Amazon S3 (Simple Storage Service) and performing other related tasks, for instance creating and removing buckets, listing objects, etc.

COMMANDS

s3cmd can do several actions specified by the following commands.

s3cmd mb s3://BUCKET
    Make bucket

s3cmd rb s3://BUCKET
    Remove bucket

s3cmd ls [s3://BUCKET[/PREFIX]]
    List objects or buckets

s3cmd la
    List all object in all buckets

s3cmd put FILE [FILE...] s3://BUCKET[/PREFIX]
    Put file into bucket

s3cmd get s3://BUCKET/OBJECT LOCAL_FILE
    Get file from bucket

s3cmd del s3://BUCKET/OBJECT
    Delete file from bucket

s3cmd sync LOCAL_DIR s3://BUCKET[/PREFIX] or s3://BUCKET[/PREFIX] LOCAL_DIR
    Synchronize a directory tree to S3

s3cmd du [s3://BUCKET[/PREFIX]]
    Disk usage by buckets

s3cmd info s3://BUCKET[/OBJECT]
    Get various information about Buckets or Files

s3cmd cp s3://BUCKET1/OBJECT1 s3://BUCKET2[/OBJECT2]
    Copy object

s3cmd mv s3://BUCKET1/OBJECT1 s3://BUCKET2[/OBJECT2]
    Move object

s3cmd setacl s3://BUCKET[/OBJECT]
    Modify Access control list for Bucket or Files

s3cmd accesslog s3://BUCKET
    Enable/disable bucket access logging

s3cmd sign STRING-TO-SIGN
    Sign arbitrary string using the secret key

s3cmd fixbucket s3://BUCKET[/PREFIX]
    Fix invalid file names in a bucket

Commands for CloudFront management

s3cmd cflist
    List CloudFront distribution points

s3cmd cfinfo [cf://DIST_ID]
    Display CloudFront distribution point parameters

s3cmd cfcreate s3://BUCKET
    Create CloudFront distribution point

s3cmd cfdelete cf://DIST_ID
    Delete CloudFront distribution point

s3cmd cfmodify cf://DIST_ID
    Change CloudFront distribution point parameters

OPTIONS

Some of the below specified options can have their default values set in s3cmd config file (by default $HOME/.s3cmd). As it's a simple text file feel free to open it with your favorite text editor and do any changes you like.

-h, --help
    show this help message and exit

--configure
    Invoke interactive (re)configuration tool.

-c FILE, --config=FILE
    Config file name. Defaults to /home/mludvig/.s3cfg

--dump-config
    Dump current configuration after parsing config files and command line options and exit.

-n, --dry-run
    Only show what should be uploaded or downloaded but don't actually do it. May still perform S3 requests to get bucket listings and other information though (only for file transfer commands)

-e, --encrypt
    Encrypt files before uploading to S3.

--no-encrypt
    Don't encrypt files.

-f, --force
    Force overwrite and other dangerous operations.

--continue
    Continue getting a partially downloaded file (only for [get] command).

--skip-existing
    Skip over files that exist at the destination (only for [get] and [sync] commands).

-r, --recursive
    Recursive upload, download or removal.

--check-md5
    Check MD5 sums when comparing files for [sync]. (default)

--no-check-md5
    Do not check MD5 sums when comparing files for [sync]. Only size will be compared. May significantly speed up transfer but may also miss some changed files.

-P, --acl-public
    Store objects with ACL allowing read for anyone.

--acl-private
    Store objects with default ACL allowing access for you only.

--acl-grant=PERMISSION:EMAIL or USER_CANONICAL_ID
    Grant stated permission to a given amazon user. Permission is one of: read, write, read_acp, write_acp, full_control, all

--acl-revoke=PERMISSION:USER_CANONICAL_ID
    Revoke stated permission for a given amazon user. Permission is one of: read, write, read_acp, wr ite_acp, full_control, all

--delete-removed
    Delete remote objects with no corresponding local file [sync]

--no-delete-removed
    Don't delete remote objects.

-p, --preserve
    Preserve filesystem attributes (mode, ownership, timestamps). Default for [sync] command.

--no-preserve
    Don't store FS attributes

--exclude=GLOB
    Filenames and paths matching GLOB will be excluded from sync

--exclude-from=FILE
    Read --exclude GLOBs from FILE

--rexclude=REGEXP
    Filenames and paths matching REGEXP (regular expression) will be excluded from sync

--rexclude-from=FILE
    Read --rexclude REGEXPs from FILE

--include=GLOB
    Filenames and paths matching GLOB will be included even if previously excluded by one of

--(r)exclude(-from) patterns

--include-from=FILE
    Read --include GLOBs from FILE

--rinclude=REGEXP
    Same as --include but uses REGEXP (regular expression) instead of GLOB

--rinclude-from=FILE
    Read --rinclude REGEXPs from FILE

--bucket-location=BUCKET_LOCATION
    Datacentre to create bucket in. As of now the datacenters are: US (default), EU, us-west-1, and ap- southeast-1

--reduced-redundancy, --rr
    Store object with 'Reduced redundancy'. Lower per-GB price. [put, cp, mv]

--access-logging-target-prefix=LOG_TARGET_PREFIX
    Target prefix for access logs (S3 URI) (for [cfmodify] and [accesslog] commands)

--no-access-logging
    Disable access logging (for [cfmodify] and [accesslog] commands)

-m MIME/TYPE, --mime-type=MIME/TYPE
    Default MIME-type to be set for objects stored.

-M, --guess-mime-type
    Guess MIME-type of files by their extension. Falls back to default MIME-Type as specified by --mime-type option

--add-header=NAME:VALUE
    Add a given HTTP header to the upload request. Can be used multiple times. For instance set 'Expires' or if you like.

--encoding=ENCODING
    Override autodetected terminal and filesystem encoding (character set). Autodetected: UTF-8

--verbatim
    Use the S3 name as given on the command line. No pre- processing, encoding, etc. Use with caution!

--list-md5
    Include MD5 sums in bucket listings (only for 'ls' command).

-H, --human-readable-sizes
    Print sizes in human readable form (eg 1kB instead of 1234).

--progress
    Display progress meter (default on TTY).

--no-progress
    Don't display progress meter (default on non-TTY).

--enable
    Enable given CloudFront distribution (only for [cfmodify] command)

--disable
    Enable given CloudFront distribution (only for [cfmodify] command)

--cf-add-cname=CNAME
    Add given CNAME to a CloudFront distribution (only for [cfcreate] and [cfmodify] commands)

--cf-remove-cname=CNAME
    Remove given CNAME from a CloudFront distribution (only for [cfmodify] command)

--cf-comment=COMMENT
    Set COMMENT for a given CloudFront distribution (only for [cfcreate] and [cfmodify] commands)

--cf-default-root-object=DEFAULT_ROOT_OBJECT
    Set the default root object to return when no object is specified in the URL. Use a relative path, i.e. default/index.html instead of /default/index.html or s3://bucket/default/index.html (only for [cfcreate] and [cfmodify] commands)

-v, --verbose
    Enable verbose output.

-d, --debug
    Enable debug output.

--version
    Show s3cmd version (1.0.0) and exit.

-F, --follow-symlinks
    Follow symbolic links as if they are regular files

EXAMPLES
One of the most powerful commands of s3cmd is s3cmd sync used for synchronising complete directory trees to or from remote S3 storage. To some extent s3cmd put and s3cmd get share a similar behaviour with sync.

Basic usage common in backup scenarios is as simple as:
	s3cmd sync /local/path/ s3://test-bucket/backup/

This command will find all files under /local/path directory and copy them to corresponding paths under s3://test-bucket/backup on the remote side. For example:
	/local/path/file1.ext         ->  s3://bucket/backup/file1.ext
	/local/path/dir123/file2.bin  ->  s3://bucket/backup/dir123/file2.bin

However if the local path doesn't end with a slash the last directory's name is used on the remote side as well. Compare these with the previous example:
	s3cmd sync /local/path s3://test-bucket/backup/
will sync:
	/local/path/file1.ext         ->  s3://bucket/backup/path/file1.ext
	/local/path/dir123/file2.bin  ->  s3://bucket/backup/path/dir123/file2.bin

To retrieve the files back from S3 use inverted syntax:
	s3cmd sync s3://test-bucket/backup/ /tmp/restore/
that will download files:
	s3://bucket/backup/file1.ext         ->  /tmp/restore/file1.ext
	s3://bucket/backup/dir123/file2.bin  ->  /tmp/restore/dir123/file2.bin

Without the trailing slash on source the behaviour is similar to what has been demonstrated with upload:
	s3cmd sync s3://test-bucket/backup /tmp/restore/
will download the files as:
	s3://bucket/backup/file1.ext         ->  /tmp/restore/backup/file1.ext
	s3://bucket/backup/dir123/file2.bin  ->  /tmp/restore/backup/dir123/file2.bin

All source file names, the bold ones above, are matched against exclude rules and those that match are then re-checked against include rules to see whether they should be excluded or kept in the source list.

For the purpose of --exclude and --include matching only the bold file names above are used. For instance only path/file1.ext is tested against the patterns, not /local/path/file1.ext

Both --exclude and --include work with shell-style wildcards (a.k.a. GLOB). For a greater flexibility s3cmd provides Regular-expression versions of the two exclude options named --rexclude and --rinclude. The options with ...-from suffix (eg --rinclude-from) expect a filename as an argument. Each line of such a file is treated as one pattern.

There is only one set of patterns built from all --(r)exclude(-from) options and similarly for include variant. Any file excluded with eg --exclude can be put back with a pattern found in --rinclude-from list.

Run s3cmd with --dry-run to verify that your rules work as expected. Use together with --debug get detailed information about matching file names against exclude and include rules.

For example to exclude all files with ".jpg" extension except those beginning with a number use:

    --exclude '*.jpg' --rinclude '[0-9].*.jpg'

SEE ALSO
For the most up to date list of options run s3cmd --help
For more info about usage, examples and other related info visit project homepage at
http://s3tools.org

DONATIONS
Please consider a donation if you have found s3cmd useful:
http://s3tools.org/donate

AUTHOR
Written by Michal Ludvig <mludvig@logix.net.nz> and 15+ contributors

CONTACT, SUPPORT
Prefered way to get support is our mailing list: s3tools-general@lists.sourceforge.net

REPORTING BUGS
Report bugs to s3tools-bugs@lists.sourceforge.net

COPYRIGHT
Copyright © 2007,2008,2009,2010,2011 Michal Ludvig <http://www.logix.cz/michal>
This is free software. You may redistribute copies of it under the terms of the GNU General Public License version 2 <http://www.gnu.org/licenses/gpl.html>. There is NO WARRANTY, to the extent permitted by law.